Remote Diagnostics

The remote diagnostics service refers to the act of running a diagnostic on a vehicle remotely. This service allows, amongst other features, to take measurements on the car at high frequencies (1Hz) for long periods of time (several hours).

This tutorial presents a full workflow example demonstrating how to acquire measurements of the following features in a continuous manner.

  • Battery Pack Soc
  • Battery Pack charge current
  • Battery Pack current
  • Battery Pack voltage
  • Mileage
  • Battery Pack temperature
  • Hybrid vehicle Battery Pack temperature
  • Charge cable status
  • Outdoor temperature
  • BMS SOHC
  • Charge or energy counter
  • Charging port state
  • Max Cell SOC
  • Min Cel SOC
  • Max Cell Voltage
  • Min Cell Voltage
  • Battery Cumulative Current (Throughput)
  • Battery Cell 1 Voltage

Prerequisites

The following actions must be performed prior to the acquisition.

  1. Sign up to connect.munic.io.
  2. Access to devices registered to the platform in question.

Glossary

RD: Acronym for remote diags, short for remote diagnostics.

VCI (Vehicle Communication Interface): The diagnostic device traditionally plugged directly to the vehicle.

Virtual VCI: Remote diag using one MUNIC dongle on the vehicle, connected to a virtual VCI on the cloud (also called “VVCI mode”).

Tunnel: Encrypted communication channel, dedicated to RD data, between MUNIC devices and the virtual VCIs on the cloud.

Getting started

This section demonstrates how to initiate a remote diagnostics session in order to execute different supported actions and monitor their results.

Note

The following guide takes provider03 as reference, supported actions and minor details may differ when using another provider.

Session Status

This operation, if executed after having launched the measurements, is also used to obtain the time series

List my visible resources
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
"""
Variables:
 
{
    "imei": "863609060285362",
    "remote_diag_id": "927114178235564039"
}

"""
query remote_diag($remote_diag_id: ID!){
    remote_diag(id: $remote_diag_id) {

        id
        vci {
            device {
                id
            }
            failure_code
            failure_reason
        }
        vud {
            device {
                id
            }
            vin
            vin_from_vehicle
            failure_code
            failure_reason
        }
        current_step
        actions{
            list{
                id
                type
                status
                created_at
                progress
            }
        }
        steps{
            list{
                id
                name
                status
                description
            }
        }
        result{

            ecus{
                list{
                    source_name
                    group_name
                    supported_parameters{
                        list{
                            id
                            name
                            unit
                            unit_name
                            readings {
                                relative_timestamps
                                __typename
                                ... on SupportedParameterReadingsFloat {
                                    values
                                }
                                ... on SupportedParameterReadingsBoolean {
                                    values
                                }
                                ... on SupportedParameterReadingsString {
                                    values
                                }
                                ... on SupportedParameterReadingsInteger {
                                    values
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
1
2
3
4
5
6
export TOKEN=<YOUR_MUNIC_CONNECT_TOKEN>

curl --request POST 'https://api.munic.io/services/ekko/v2/graphql' \
--header "Authorization: Bearer $TOKEN" \
--header "Content-Type: application/json" \
--data '{"query": "query remote_diag($remote_diag_id: ID!){\n    remote_diag(id: $remote_diag_id) {\n\n        id\n        vci {\n            device {\n                id\n            }\n            failure_code\n            failure_reason\n        }\n        vud {\n            device {\n                id\n            }\n            vin\n            vin_from_vehicle\n            failure_code\n            failure_reason\n        }\n        current_step\n        actions{\n            list{\n                id\n                type\n                status\n                created_at\n                progress\n            }\n        }\n        steps{\n            list{\n                id\n                name\n                status\n                description\n            }\n        }\n        result{\n\n            ecus{\n                list{\n                    source_name\n                    group_name\n                    supported_parameters{\n                        list{\n                            id\n                            name\n                            unit\n                            unit_name\n                            readings {\n                                relative_timestamps\n                                __typename\n                                ... on SupportedParameterReadingsFloat {\n                                    values\n                                }\n                                ... on SupportedParameterReadingsBoolean {\n                                    values\n                                }\n                                ... on SupportedParameterReadingsString {\n                                    values\n                                }\n                                ... on SupportedParameterReadingsInteger {\n                                    values\n                                }\n                            }\n                        }\n                    }\n                }\n            }\n        }\n    }\n}", "variables":{    "imei": "863609060285362",    "remote_diag_id": "927114178235564039"}}'
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
import requests

token = <YOUR_MUNIC_CONNECT_TOKEN>
url = "https://api.munic.io/services/ekko/v2/graphql"

payload = """
{"query": "query remote_diag($remote_diag_id: ID!){
    remote_diag(id: $remote_diag_id) {

        id
        vci {
            device {
                id
            }
            failure_code
            failure_reason
        }
        vud {
            device {
                id
            }
            vin
            vin_from_vehicle
            failure_code
            failure_reason
        }
        current_step
        actions{
            list{
                id
                type
                status
                created_at
                progress
            }
        }
        steps{
            list{
                id
                name
                status
                description
            }
        }
        result{

            ecus{
                list{
                    source_name
                    group_name
                    supported_parameters{
                        list{
                            id
                            name
                            unit
                            unit_name
                            readings {
                                relative_timestamps
                                __typename
                                ... on SupportedParameterReadingsFloat {
                                    values
                                }
                                ... on SupportedParameterReadingsBoolean {
                                    values
                                }
                                ... on SupportedParameterReadingsString {
                                    values
                                }
                                ... on SupportedParameterReadingsInteger {
                                    values
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}", "variables":
{
    "imei": "863609060285362",
    "remote_diag_id": "927114178235564039"
}
}
"""

payload = payload.replace("\n", "")

headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer %s'%(token)
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
See JSON Answer
{
    "data": {
        "remote_diag": {
            "actions": {
                "list": [
                    {
                        "created_at": "2024-01-08T09:24:01.130Z",
                        "id": "932693414459899918",
                        "progress": 100.0,
                        "status": "SUCCESS",
                        "type": "READ_LIVE_PARAMETERS"
                    },
                    {
                        "created_at": "2024-01-08T09:17:49.527Z",
                        "id": "932692196196220937",
                        "progress": 100.0,
                        "status": "SUCCESS",
                        "type": "REQUEST_SUPPORTED_PARAMETERS"
                    },
                    {
                        "created_at": "2024-01-08T09:10:59.167Z",
                        "id": "941812431051456520",
                        "progress": 100.0,
                        "status": "SUCCESS",
                        "type": "REQUEST_VEHICLE_VIN"
                    }
                ]
            },
            "current_step": "CANCELLED",
            "id": "932692049741381645",
            "result": {
                "supported_parameters": {
                    "list": [
                        {
                            "id": "932693339414167565",
                            "name": "battTemp",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [
                                    0.0,
                                    1066.0,
                                    2088.0,
                                    3065.0,
                                    4065.0,
                                    5064.0,
                                    6064.0,
                                    7064.0,
                                    8064.0,
                                    9063.0,
                                    10063.0,
                                    11064.0,
                                    12068.0,
                                    13088.0,
                                    14073.0,
                                    15065.0,
                                    16065.0,
                                    17065.0,
                                    18064.0,
                                    19064.0,
                                    20064.0,
                                    21064.0,
                                    22063.0,
                                    23062.0,
                                    24063.0,
                                    25063.0,
                                    26063.0,
                                    27064.0,
                                    28063.0,
                                    29080.0,
                                    30065.0,
                                    31064.0,
                                    32064.0,
                                    33065.0,
                                    34065.0,
                                    35064.0,
                                    36087.0,
                                    37063.0,
                                    38063.0,
                                    39063.0,
                                    40082.0
                                ],
                                "values": [
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5,
                                    22.5
                                ]
                            },
                            "unit": "CELSIUS",
                            "unit_name": "celsius"
                        },
                        {
                            "id": "927092909582483461",
                            "name": "odometer",
                            "readings": {
                                "__typename": "SupportedParameterReadingsInteger",
                                "relative_timestamps": [
                                    4704.0,
                                    5771.0,
                                    6837.0,
                                    7765.0,
                                    8768.0,
                                    9765.0,
                                    10774.0,
                                    11761.0,
                                    12763.0,
                                    13767.0,
                                    14759.0,
                                    15762.0,
                                    16758.0,
                                    17802.0,
                                    18762.0,
                                    19767.0,
                                    20759.0,
                                    21762.0,
                                    22765.0,
                                    23768.0,
                                    24760.0,
                                    25760.0,
                                    26763.0,
                                    27760.0,
                                    28816.0,
                                    29766.0,
                                    30762.0,
                                    31762.0,
                                    32761.0,
                                    33765.0,
                                    34773.0,
                                    35765.0,
                                    36771.0,
                                    37764.0,
                                    38808.0,
                                    39793.0,
                                    40766.0,
                                    41764.0,
                                    42772.0,
                                    43770.0
                                ],
                                "values": [
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592,
                                    9592
                                ]
                            },
                            "unit": "KILOMETER",
                            "unit_name": "kilometer"
                        },
                        {
                            "id": "932693339414134797",
                            "name": "batteryVoltage",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [],
                                "values": []
                            },
                            "unit": "NONE",
                            "unit_name": ""
                        },
                        {
                            "id": "932693339414298637",
                            "name": "terminal15",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [],
                                "values": []
                            },
                            "unit": "NONE",
                            "unit_name": ""
                        },
                        {
                            "id": "932693339414200333",
                            "name": "readDtc",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [],
                                "values": []
                            },
                            "unit": "NONE",
                            "unit_name": ""
                        },
                        {
                            "id": "932693339414233101",
                            "name": "readDtc001",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [],
                                "values": []
                            },
                            "unit": "NONE",
                            "unit_name": ""
                        },
                        {
                            "id": "932693339414265869",
                            "name": "eraseDtc",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [],
                                "values": []
                            },
                            "unit": "NONE",
                            "unit_name": ""
                        },
                        {
                            "id": "932693339414102029",
                            "name": "battery_charge_a",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [],
                                "values": []
                            },
                            "unit": "NONE",
                            "unit_name": ""
                        },
                        {
                            "id": "932693339414331405",
                            "name": "readDtc002",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [],
                                "values": []
                            },
                            "unit": "NONE",
                            "unit_name": ""
                        },
                        {
                            "id": "932693339414364173",
                            "name": "eraseDtc001",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [],
                                "values": []
                            },
                            "unit": "NONE",
                            "unit_name": ""
                        },
                        {
                            "id": "932693339414396941",
                            "name": "terminal15001",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [],
                                "values": []
                            },
                            "unit": "NONE",
                            "unit_name": ""
                        },
                        {
                            "id": "932693339414069261",
                            "name": "chargeLevel",
                            "readings": {
                                "__typename": "SupportedParameterReadingsFloat",
                                "relative_timestamps": [],
                                "values": []
                            },
                            "unit": "NONE",
                            "unit_name": ""
                        }
                    ]
                }
            },
            "steps": {
                "list": [
                    {
                        "description": "Canceling Virtual Remote Diag Session Tunnel",
                        "id": "932693816271962125",
                        "name": "VirtualCancelStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Establishing Remote Diagnostic Tunnel",
                        "id": "932692125374677006",
                        "name": "StartVvciVehStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Retrieving Vehicle VIN",
                        "id": "932692124066021390",
                        "name": "VinStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Waiting for user consent",
                        "id": "932692110290649101",
                        "name": "BreakpointStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Retreive virtual VCI",
                        "id": "932692108974981133",
                        "name": "GetVvciStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Checking Vehicle Mouvement State",
                        "id": "932692054411608077",
                        "name": "MvtStateStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Checking Vehicle Device Responsiveness",
                        "id": "932692051992346637",
                        "name": "ConnectionStateStep",
                        "status": "SUCCESS"
                    }
                ]
            },
            "vci": {
                "device": {
                    "id": "VVCI_863609060285362"
                }
            },
            "vud": {
                "device": {
                    "id": "863609060285362"
                },
                "vin": "WVWZZZE14PP000000",
                "vin_from_vehicle": "WVWZZZE14PP000000",
                "failure_code": 0,
                "failure_reason": "OK",
            }
        }
    }
}

See More

Remote Diagnostic current step and Action Status

Filters

Preferred Signal

Each measured signal, depending on the model, may have several alternatives originating from different ECUs. The quality of such signals is not guaranteed to be equal which is why the boolean field preferred is defined to designate the signal with the best quality.

The result of the status can be filtered using this field, set to either true or false.

In the following example, the chargeLevel001 signal is preferred over the other chargeLevel signals.

List my visible resources
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
"""
Variables:
 
{
    "imei": "863609060285362",
    "remote_diag_id": "927114178235564039"
}

"""
query($remote_diag_id: ID!){
    remote_diag(id: $remote_diag_id) {
        id
        vci {
            device {
                id
            }
        }
        vud {
            vin
        }
        current_step
        actions{
            list{
                id
                type
                status
                created_at
                progress
            }
        }
        steps{
            list{
                id
                name
                status
                description
            }
        }
        result{
            ecus{
                list{
                    id
                    group_name
                    source_name
                    supported_parameters(preferred:true){
                        list{
                           id
                           name
                           unit
                           unit_name
                           preferred
                           readings {
                                relative_timestamps
                                __typename
                                ... on SupportedParameterReadingsFloat {
                                    values
                                }
                                ... on SupportedParameterReadingsBoolean {
                                    values
                                }
                                ... on SupportedParameterReadingsString {
                                    values
                                }
                                ... on SupportedParameterReadingsInteger {
                                    values
                                }
                           }
                        }
                    }
                }
            }
        }
    }
}
1
2
3
4
5
6
export TOKEN=<YOUR_MUNIC_CONNECT_TOKEN>

curl --request POST 'https://api.munic.io/services/ekko/v2/graphql' \
--header "Authorization: Bearer $TOKEN" \
--header "Content-Type: application/json" \
--data '{"query": "query($remote_diag_id: ID!){\n    remote_diag(id: $remote_diag_id) {\n        id\n        vci {\n            device {\n                id\n            }\n        }\n        vud {\n            vin\n        }\n        current_step\n        actions{\n            list{\n                id\n                type\n                status\n                created_at\n                progress\n            }\n        }\n        steps{\n            list{\n                id\n                name\n                status\n                description\n            }\n        }\n        result{\n            ecus{\n                list{\n                    id\n                    group_name\n                    source_name\n                    supported_parameters(preferred:true){\n                        list{\n                           id\n                           name\n                           unit\n                           unit_name\n                           preferred\n                           readings {\n                                relative_timestamps\n                                __typename\n                                ... on SupportedParameterReadingsFloat {\n                                    values\n                                }\n                                ... on SupportedParameterReadingsBoolean {\n                                    values\n                                }\n                                ... on SupportedParameterReadingsString {\n                                    values\n                                }\n                                ... on SupportedParameterReadingsInteger {\n                                    values\n                                }\n                           }\n                        }\n                    }\n                }\n            }\n        }\n    }\n}", "variables":{    "imei": "863609060285362",    "remote_diag_id": "927114178235564039"}}'
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
import requests

token = <YOUR_MUNIC_CONNECT_TOKEN>
url = "https://api.munic.io/services/ekko/v2/graphql"

payload = """
{"query": "query($remote_diag_id: ID!){
    remote_diag(id: $remote_diag_id) {
        id
        vci {
            device {
                id
            }
        }
        vud {
            vin
        }
        current_step
        actions{
            list{
                id
                type
                status
                created_at
                progress
            }
        }
        steps{
            list{
                id
                name
                status
                description
            }
        }
        result{
            ecus{
                list{
                    id
                    group_name
                    source_name
                    supported_parameters(preferred:true){
                        list{
                           id
                           name
                           unit
                           unit_name
                           preferred
                           readings {
                                relative_timestamps
                                __typename
                                ... on SupportedParameterReadingsFloat {
                                    values
                                }
                                ... on SupportedParameterReadingsBoolean {
                                    values
                                }
                                ... on SupportedParameterReadingsString {
                                    values
                                }
                                ... on SupportedParameterReadingsInteger {
                                    values
                                }
                           }
                        }
                    }
                }
            }
        }
    }
}", "variables":
{
    "imei": "863609060285362",
    "remote_diag_id": "927114178235564039"
}
}
"""

payload = payload.replace("\n", "")

headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer %s'%(token)
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
See JSON Answer
{
    "data": {
        "remote_diag": {
            "actions": {
                "list": [
                    {
                        "created_at": "2023-12-19T14:38:26.996Z",
                        "id": "927092922900676613",
                        "progress": 100.0,
                        "status": "SUCCESS",
                        "type": "READ_LIVE_PARAMETERS"
                    },
                    {
                        "created_at": "2023-12-19T14:36:15.753Z",
                        "id": "927092492857966599",
                        "progress": 100.0,
                        "status": "SUCCESS",
                        "type": "REQUEST_SUPPORTED_PARAMETERS"
                    }
                ]
            },
            "current_step": "CANCELLED",
            "id": "927092369263788037",
            "result": {
                "ecus": {
                    "list": [
                        {
                            "group_name": "N/A",
                            "id": "927092909143654405",
                            "source_name": "FEATURE_PROTOCOL",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927092909582286853",
                                        "name": "chargeLevel001",
                                        "preferred": true,
                                        "readings": {
                                            "relative_timestamps": [
                                                4152.0,
                                                5221.0,
                                                6216.0,
                                                7211.0,
                                                8210.0,
                                                9209.0,
                                                10211.0,
                                                11206.0,
                                                12261.0,
                                                13209.0,
                                            ],
                                            "values": [
                                                45.7,
                                                45.7,
                                                45.7,
                                                45.7,
                                                45.7,
                                                45.7,
                                                45.7,
                                                45.7,
                                                45.7,
                                                45.7,
                                            ]
                                        },
                                        "unit": "OTHER",
                                        "unit_name": "percent"
                                    }
                                ]
                            }
                        }
                    ]
                }
            }
        }
    }
}

Session Setup

A remote diagnostic session is setup for a given device as follows.

Create Session

A session is defined by the following variables.

  • imei id: The device IMEI.
  • provider name: The provider name, provider_03 for this use case.

Once successfully created, a remote diagnostics ID is returned to be passed as a parameter to all subsequent commands.

List my visible resources
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
"""
Variables:
 
{
  "imei": "863609060285362",
  "provider_name":"provider_03"
}

"""
mutation remote_diag_create(
  $imei: ID!,
  $provider_name: String
){
remote_diag_create(
  vud_device_id: $imei,
  provider_name: $provider_name){
    id
  }
}
1
2
3
4
5
6
export TOKEN=<YOUR_MUNIC_CONNECT_TOKEN>

curl --request POST 'https://api.munic.io/services/ekko/v2/graphql' \
--header "Authorization: Bearer $TOKEN" \
--header "Content-Type: application/json" \
--data '{"query": "mutation remote_diag_create(\n  $imei: ID!,\n  $provider_name: String\n){\nremote_diag_create(\n  vud_device_id: $imei,\n  provider_name: $provider_name){\n    id\n  }\n}", "variables":{  "imei": "863609060285362",  "provider_name":"provider_03"}}'
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
import requests

token = <YOUR_MUNIC_CONNECT_TOKEN>
url = "https://api.munic.io/services/ekko/v2/graphql"

payload = """
{"query": "mutation remote_diag_create(
  $imei: ID!,
  $provider_name: String
){
remote_diag_create(
  vud_device_id: $imei,
  provider_name: $provider_name){
    id
  }
}", "variables":
{
  "imei": "863609060285362",
  "provider_name":"provider_03"
}
}
"""

payload = payload.replace("\n", "")

headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer %s'%(token)
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
See JSON Answer
{
  "data": {
    "remote_diag_create": {
      "id": "927114178235564039"
    }
  }
}

See More

Note

The user must ensure that they are authorized to operate on the device used for this session or else, a 106 Asset not found error will be raised.

Note

The device must be connected to the cloud before a session is created. Otherwise, a 200 Device is disconnected error will be raised.

Keep in mind that the device may take some time to setup its communication with the cloud, up to a few minutes.

Create session answer

Once the session is created, the status must be monitored until it is ready to proceed to the next operation.

{
    "current_step": "READY",
    "id": "927114178235564039"
}

Start Session

This operation sets up a secure communication tunnel between the device and the VVCI. The following variables are defined.

  • imei id: The device IMEI.
  • Remote diagnostics ID: The ID of the recently created session.
  • vin: The Vehicle identification number (VIN) of the associated vehicle, 17 characters long.
List my visible resources
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
"""
Variables:
 
{
    "imei": "863609060285362",
    "remote_diag_id": "927114178235564039",
    "vin": "WAUZZZ8U7GR025151"
}

"""
mutation remote_diag_start(
    $remote_diag_id: ID!,
    $vin: String
){
    remote_diag_start(id: $remote_diag_id, vin: $vin){
        id
    }
}
1
2
3
4
5
6
export TOKEN=<YOUR_MUNIC_CONNECT_TOKEN>

curl --request POST 'https://api.munic.io/services/ekko/v2/graphql' \
--header "Authorization: Bearer $TOKEN" \
--header "Content-Type: application/json" \
--data '{"query": "mutation remote_diag_start(\n    $remote_diag_id: ID!,\n    $vin: String\n){\n    remote_diag_start(id: $remote_diag_id, vin: $vin){\n        id\n    }\n}", "variables":{    "imei": "863609060285362",    "remote_diag_id": "927114178235564039",    "vin": "WAUZZZ8U7GR025151"}}'
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
import requests

token = <YOUR_MUNIC_CONNECT_TOKEN>
url = "https://api.munic.io/services/ekko/v2/graphql"

payload = """
{"query": "mutation remote_diag_start(
    $remote_diag_id: ID!,
    $vin: String
){
    remote_diag_start(id: $remote_diag_id, vin: $vin){
        id
    }
}", "variables":
{
    "imei": "863609060285362",
    "remote_diag_id": "927114178235564039",
    "vin": "WAUZZZ8U7GR025151"
}
}
"""

payload = payload.replace("\n", "")

headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer %s'%(token)
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
See JSON Answer
{
    "data": {
        "remote_diag_start": {
            "id": "927114178235564039"
        }
    }
}

See More

Note

The variable vin is optional.

Start Session answer

Once the session is started, the status must be monitored until it is ready to proceed to the next operation.

{
    "current_step": "READY",
    "id": "927114178235564039"
}
See JSON Answer
{
    "data": {
        "remote_diag": {
            "actions": {
                "list": []
            },
            "current_step": "READY",
            "id": "927114178235564039",
            "result": null,
            "steps": {
                "list": [
                    {
                        "description": "Establishing Remote Diagnostic Tunnel",
                        "id": "927347422586011652",
                        "name": "StartVvciVehStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Retrieving Vehicle VIN",
                        "id": "927347422402084868",
                        "name": "VinStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Waiting for user consent",
                        "id": "927326904910315527",
                        "name": "BreakpointStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Retreive virtual VCI",
                        "id": "927326904639094791",
                        "name": "GetVvciStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Checking Vehicle Mouvement State",
                        "id": "927326866289557509",
                        "name": "MvtStateStep",
                        "status": "SUCCESS"
                    },
                    {
                        "description": "Checking Vehicle Device Responsiveness",
                        "id": "927326865405706245",
                        "name": "ConnectionStateStep",
                        "status": "SUCCESS"
                    }
                ]
            },
            "vci": {
                "device": {
                    "id": "VVCI_863609060285362"
                }
            },
            "vud": {
                "vin": "WAUZZZ8U7GR025151"
            }
        }
    }
}

Vin Validation

The vin validation is possible according to 2 scenarios:

  • Should Validate Vin: is an automatic process.
  • Manual Vin validation: is a completely manual process.

Should Validate Vin

In this scenario the vin given by user will be automatically compared to the vin detected on the vehicle. The action Request Vin Vehicle is also automatically launched.

List my visible resources
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
"""
Variables:
 
{
    "imei": "863609060285362",
    "remote_diag_id": "927114178235564039",
    "vin": "WAUZZZ8U7GR025151",
    "should_validate_vin": true
}

"""
mutation remote_diag_start(
    $remote_diag_id: ID!,
    $vin: String,
    $shouldValidateVin: Boolean
){
    remote_diag_start(id: $remote_diag_id, vin: $vin, shouldValidateVin: $should_validate_vin){
        id
    }
}
1
2
3
4
5
6
export TOKEN=<YOUR_MUNIC_CONNECT_TOKEN>

curl --request POST 'https://api.munic.io/services/ekko/v2/graphql' \
--header "Authorization: Bearer $TOKEN" \
--header "Content-Type: application/json" \
--data '{"query": "mutation remote_diag_start(\n    $remote_diag_id: ID!,\n    $vin: String,\n    $shouldValidateVin: Boolean\n){\n    remote_diag_start(id: $remote_diag_id, vin: $vin, shouldValidateVin: $should_validate_vin){\n        id\n    }\n}", "variables":{    "imei": "863609060285362",    "remote_diag_id": "927114178235564039",    "vin": "WAUZZZ8U7GR025151",    "should_validate_vin": true}}'
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
import requests

token = <YOUR_MUNIC_CONNECT_TOKEN>
url = "https://api.munic.io/services/ekko/v2/graphql"

payload = """
{"query": "mutation remote_diag_start(
    $remote_diag_id: ID!,
    $vin: String,
    $shouldValidateVin: Boolean
){
    remote_diag_start(id: $remote_diag_id, vin: $vin, shouldValidateVin: $should_validate_vin){
        id
    }
}", "variables":
{
    "imei": "863609060285362",
    "remote_diag_id": "927114178235564039",
    "vin": "WAUZZZ8U7GR025151",
    "should_validate_vin": true
}
}
"""

payload = payload.replace("\n", "")

headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer %s'%(token)
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
See JSON Answer
{
    "data": {
        "remote_diag_start": {
            "id": "927114178235564039"
        }
    }
}

See More

Note

Any other result than equality between VIN detectected by vehicle equals vin given by user will produce a session error.

The progress of vin validation can be tracked with this status.

Possible errors are:

  • UNABLE_TO_RETRIEVE_VIN_FROM_VEHICLE
  • VIN_READ_FROM_VEHICLE_MISMATCH_WITH_ANNOUNCED_VIN
{
    "vud": {
        "device": {
            "id": "863609060285362"
        },
        "vin": "WVWZZZE14PP000000",
        "vin_from_vehicle": "",
        "failure_code": 502,
        "failure_reason": "UNABLE_TO_RETRIEVE_VIN_FROM_VEHICLE",
    }
}
{
    "vud": {
        "device": {
            "id": "863609060285362"
        },
        "vin": "WVWZZZE14PP000000",
        "vin_from_vehicle": "WVWZZZE14PP000123",
        "failure_code": 503,
        "failure_reason": "VIN_READ_FROM_VEHICLE_MISMATCH_WITH_ANNOUNCED_VIN",
    }
}

See More

Manual Vin Validation

In this scenario the vin validation is made by the user.

  • Start the session
  • Start Request Vehicle Vin
  • Manually compare vin_read_from_vehicle with vin
  • If the 2 vin are not the same the user can restart or continue the session. If the session continue the vin will be used for all this session.

Action Management

This section documents in details how to start, monitor and stop an action. The following two actions are available for the previously specified provider, provider03.

  • REQUEST_VEHICLE_VIN
  • REQUEST_SUPPORTED_PARAMETERS
  • READ_LIVE_PARAMETERS

Action Request Vehicle Vin

This action is used to request the vin detected by the vehicle The progress of request vehicle vin can be tracked with this status.

List my visible resources
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
"""
Variables:
 
{
    "imei": "351622075294922",
    "remote_diag_id": "927114178235564039",
    "action": "REQUEST_VEHICLE_VIN"
}

"""
mutation remote_diag_action_create(
    $remote_diag_id: ID!,
    $action: RemoteDiagActionTypeArg!
) {
    remote_diag_action_create(
        remote_diag_id: $remote_diag_id,
        action: $action,
    ){
    id
  }
}
1
2
3
4
5
6
export TOKEN=<YOUR_MUNIC_CONNECT_TOKEN>

curl --request POST 'https://api.munic.io/services/ekko/v2/graphql' \
--header "Authorization: Bearer $TOKEN" \
--header "Content-Type: application/json" \
--data '{"query": "mutation remote_diag_action_create(\n    $remote_diag_id: ID!,\n    $action: RemoteDiagActionTypeArg!\n) {\n    remote_diag_action_create(\n        remote_diag_id: $remote_diag_id,\n        action: $action,\n    ){\n    id\n  }\n}", "variables":{    "imei": "351622075294922",    "remote_diag_id": "927114178235564039",    "action": "REQUEST_VEHICLE_VIN"}}'
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
import requests

token = <YOUR_MUNIC_CONNECT_TOKEN>
url = "https://api.munic.io/services/ekko/v2/graphql"

payload = """
{"query": "mutation remote_diag_action_create(
    $remote_diag_id: ID!,
    $action: RemoteDiagActionTypeArg!
) {
    remote_diag_action_create(
        remote_diag_id: $remote_diag_id,
        action: $action,
    ){
    id
  }
}", "variables":
{
    "imei": "351622075294922",
    "remote_diag_id": "927114178235564039",
    "action": "REQUEST_VEHICLE_VIN"
}
}
"""

payload = payload.replace("\n", "")

headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer %s'%(token)
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
See JSON Answer
{
    "data": {
        "remote_diag_action_create": {
            "id": "927114178235564039"
        }
    }
}

See More

Action identification

This action is used to identify the supported parameters that can be measured on the vehicle

The variables used are :

  • imei id: The device IMEI.
  • Remote diagnostics ID: The ID of the recently created session.
  • Action: “REQUEST_SUPPORTED_PARAMETERS

The progress of identification can be tracked with this status.

List my visible resources
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
"""
Variables:
 
{
    "imei": "351622075294922",
    "remote_diag_id": "927114178235564039",
    "action": "REQUEST_SUPPORTED_PARAMETERS"
}

"""
mutation remote_diag_action_create(
    $remote_diag_id: ID!,
    $action:RemoteDiagActionTypeArg!
) {
    remote_diag_action_create(
        remote_diag_id: $remote_diag_id,
        action: $action
    ){
        id
        ecus
    }
}
1
2
3
4
5
6
export TOKEN=<YOUR_MUNIC_CONNECT_TOKEN>

curl --request POST 'https://api.munic.io/services/ekko/v2/graphql' \
--header "Authorization: Bearer $TOKEN" \
--header "Content-Type: application/json" \
--data '{"query": "mutation remote_diag_action_create(\n    $remote_diag_id: ID!,\n    $action:RemoteDiagActionTypeArg!\n) {\n    remote_diag_action_create(\n        remote_diag_id: $remote_diag_id,\n        action: $action\n    ){\n        id\n        ecus\n    }\n}", "variables":{    "imei": "351622075294922",    "remote_diag_id": "927114178235564039",    "action": "REQUEST_SUPPORTED_PARAMETERS"}}'
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
import requests

token = <YOUR_MUNIC_CONNECT_TOKEN>
url = "https://api.munic.io/services/ekko/v2/graphql"

payload = """
{"query": "mutation remote_diag_action_create(
    $remote_diag_id: ID!,
    $action:RemoteDiagActionTypeArg!
) {
    remote_diag_action_create(
        remote_diag_id: $remote_diag_id,
        action: $action
    ){
        id
        ecus
    }
}", "variables":
{
    "imei": "351622075294922",
    "remote_diag_id": "927114178235564039",
    "action": "REQUEST_SUPPORTED_PARAMETERS"
}
}
"""

payload = payload.replace("\n", "")

headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer %s'%(token)
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
See JSON Answer
{
    "data": {
        "remote_diag_action_create": {
            "ecus": [],
            "id": "927348396615827460"
        }
    }
}

See More

Identification answer

The identification process may a few minutes, up to 5 minutes, depending on the vehicle. The process is considered done when the progress is equal to 100%.

The supported parameters can be found in the status answer.

For exemple:

{
    "type": "REQUEST_SUPPORTED_PARAMETERS",
    "name": "odometer",
    "readings": {
        "relative_timestamps": [],
        "values": []
        },
    "unit": "KILOMETER",
}
See JSON Complete Answer
{
    "data": {
        "remote_diag": {
            "actions": {
                "list": [
                    {
                        "created_at": "2023-12-20T12:17:51.390Z",
                        "id": "927348396615827460",
                        "progress": 100.0,
                        "status": "SUCCESS",
                        "type": "REQUEST_SUPPORTED_PARAMETERS"
                    }
                ]
            },
            "current_step": "READY",
            "id": "927114178235564039",
            "result": {
                "ecus": {
                    "list": [
                        {
                            "group_name": "Diagnose",
                            "id": "927348564489142279",
                            "source_name": "INSTRUMENT",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564864073735",
                                        "name": "odometer",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "KILOMETER",
                                        "unit_name": "kilometer"
                                    },
                                    {
                                        "id": "927348564864073735",
                                        "name": "eraseDtc007",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864106503",
                                        "name": "serviceKmSinceLastInspection",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864139271",
                                        "name": "serviceKmIntervalInspection",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864172039",
                                        "name": "fuelConsumption",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864204807",
                                        "name": "engineTemp",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864237575",
                                        "name": "oilLevelWarning",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864270343",
                                        "name": "terminal15005",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864303111",
                                        "name": "fuelConsumptionAvg",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864335879",
                                        "name": "serviceDayIntervalInspection",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864368647",
                                        "name": "serviceDayInterval",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864401415",
                                        "name": "serviceDaysSinceLastInspection",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864434183",
                                        "name": "serviceKmInterval",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864466951",
                                        "name": "outdoor_temp_cel",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864499719",
                                        "name": "serviceDaysSinceLast",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864532487",
                                        "name": "serviceKmSinceLast",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864565255",
                                        "name": "brakeLevelWarning",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864598023",
                                        "name": "washerLevelWarning",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864630791",
                                        "name": "coolerLevelWarning",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864663559",
                                        "name": "seatBeltFrontLeft",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864040967",
                                        "name": "readDtc007",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Diagnose",
                            "id": "927348564470693895",
                            "source_name": "MULTIFUNCTION",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564863909895",
                                        "name": "eraseDtc005",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863877127",
                                        "name": "readDtc005",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Diagnostic for data-bus",
                            "id": "927348564452278279",
                            "source_name": "MULTIFUNCTION",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564863746055",
                                        "name": "eraseDtc004",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863778823",
                                        "name": "batteryVoltage001",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863811591",
                                        "name": "battery_current",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863844359",
                                        "name": "terminal15003",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863713287",
                                        "name": "readDtc004",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Diagnose",
                            "id": "927348564433731591",
                            "source_name": "AC",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564863418375",
                                        "name": "eraseDtc001",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863451143",
                                        "name": "indoorTemperature",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863483911",
                                        "name": "terminal15001",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863385607",
                                        "name": "readDtc001",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Passenger door",
                            "id": "927348564415217671",
                            "source_name": "MULTIFUNCTION",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564864729095",
                                        "name": "eraseDtc008",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864696327",
                                        "name": "readDtc008",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Highbeam assist",
                            "id": "927348564397719559",
                            "source_name": "MULTIFUNCTION",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564863975431",
                                        "name": "eraseDtc006",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864008199",
                                        "name": "terminal15004",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863942663",
                                        "name": "readDtc006",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Diagnose",
                            "id": "927348564378910727",
                            "source_name": "MULTIFUNCTION",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564863549447",
                                        "name": "eraseDtc002",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863582215",
                                        "name": "batteryVoltage",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863614983",
                                        "name": "terminal15002",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863516679",
                                        "name": "readDtc002",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Diagnose",
                            "id": "927348564361478151",
                            "source_name": "MULTIFUNCTION",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564863320071",
                                        "name": "eraseDtc",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863352839",
                                        "name": "terminal15",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564863287303",
                                        "name": "readDtc",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": null,
                            "id": "927348564343062535",
                            "source_name": "FEATURE_PROTOCOL",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564863156231",
                                        "name": "fuelLevel",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Rear right door",
                            "id": "927348564322320391",
                            "source_name": "MULTIFUNCTION",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564864860167",
                                        "name": "eraseDtc010",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864827399",
                                        "name": "readDtc010",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Diagnose",
                            "id": "927348564305772551",
                            "source_name": "MULTIFUNCTION",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564865024007",
                                        "name": "eraseDtc012",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564865056775",
                                        "name": "terminal15006",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564865089543",
                                        "name": "steeringWheelAngle",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864991239",
                                        "name": "readDtc012",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Diagnose",
                            "id": "927348564288667655",
                            "source_name": "AIRBAG",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564864925703",
                                        "name": "eraseDtc011",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864958471",
                                        "name": "seatBeltFrontLeft001",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864892935",
                                        "name": "readDtc011",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "Rear left door",
                            "id": "927348564271202311",
                            "source_name": "MULTIFUNCTION",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564864794631",
                                        "name": "eraseDtc009",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564864761863",
                                        "name": "readDtc009",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": null,
                            "id": "927348564253245447",
                            "source_name": "FEATURE_PROTOCOL",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564863221767",
                                        "name": "serviceDaysToNext",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    }
                                ]
                            }
                        },
                        {
                            "group_name": "N/A",
                            "id": "927348564234665991",
                            "source_name": "FUEL_IGNITION",
                            "supported_parameters": {
                                "list": [
                                    {
                                        "id": "927348564866334727",
                                        "name": "fuelPressure002",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866367495",
                                        "name": "atmosphericPressure002",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866400263",
                                        "name": "engineTemp003",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866433031",
                                        "name": "boostPressure002",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866465799",
                                        "name": "intakeAirTemperature002",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866498567",
                                        "name": "fuelConsumption003",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866531335",
                                        "name": "oilLevelMeasured001",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866564103",
                                        "name": "oilLevelLimit002",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866596871",
                                        "name": "FuelTemp",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866629639",
                                        "name": "readDtc017",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866662407",
                                        "name": "eraseDtc017",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866695175",
                                        "name": "batteryVoltage005",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866727943",
                                        "name": "outdoor_temp_cel002",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866760711",
                                        "name": "engineTemp004",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866793479",
                                        "name": "terminal15008",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866826247",
                                        "name": "engine_speed001",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866859015",
                                        "name": "oil_temp_cel001",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
                                        "unit": "NONE",
                                        "unit_name": ""
                                    },
                                    {
                                        "id": "927348564866891783",
                                        "name": "oilLevelMeasured002",
                                        "readings": {
                                            "relative_timestamps": [],
                                            "values": []
                                        },
[...]
